from cloudcontrol.server.clients import Client
from cloudcontrol.server.clients.host import HostClient

from cloudcontrol.server.db import SObject
from cloudcontrol.common.tql.db.tag import StaticTag


class BootstrapClient(HostClient):

    """ A bootstrap client connected to the cc-server.
    """

    ROLE = 'bootstrap'

    def _get_tql_object(self):
        tql_object = SObject(self.login)
        tql_object.register(StaticTag('r', self.role))
        self._server.db.register(tql_object)
        return tql_object

    @property
    def login(self):
        return '%s.%s' % (self._login, self.conn.get_fd())

    @property
    def role(self):
        return 'host'

    def shutdown(self):
        super(BootstrapClient, self).shutdown()
        # Also, remote the object from the db:
        self._server.db.unregister(self.login)


Client.register_client_class(BootstrapClient)
